import {html, PolymerElement} from '@polymer/polymer/polymer-element.js';
import {afterNextRender} from '@polymer/polymer/lib/utils/render-status.js';
import './muuri.js';
/**
 * `muuri-layout`
 * a wrapper for the muuri javascript library
 *
 * @customElement
 * @polymer
 * @demo demo/index.html
 */
class MuuriLayout extends PolymerElement {
  static get template() {
    return html`
      <style>
        :host {
            position: relative;
            width: 100%;
        }
      </style>
        
      <slot id="slot"></slot>
    `;
  }
  
  static get properties() {
    return {
      class: {
        reflectToAttribute: true,
        value: 'grid',
      },
    };
  }
  
  init(){
      this.raw = new Muuri(this, {
            showDuration: 2000
        });
      console.log('init called!');
      afterNextRender(this, function () {
            //this.layout();
        });
  }
  
  connectedCallback() {
    super.connectedCallback();
    this.init();
    console.log('muuri-layout created!');
  }
  
  addItemToGrid(){
    //create the wrapping element
    var newElement = document.createElement("div");
    newElement.classList.add("item");
    //create the inner element
    var innerElement = document.createElement("div");
    innerElement.classList.add("item-content");
    
    innerElement.appendChild(this.createNewThing("New Node"));
    
    newElement.appendChild(innerElement);
   
    var element =this.raw.getElement();
    element.appendChild(newElement);
  
    this.raw.add(newElement);
    this.raw.show(newElement);
    }
  
  createNewThing(text){
      var newElement = document.createElement("div");
      newElement.innerHTML = text;
      return newElement;
  }
}

window.customElements.define('muuri-layout', MuuriLayout);
